#include "system.h"
#include "Event.h"
#include "json.h"

//Variables privadas
static char ssid[] = "Casa_2.4GHz";
static char password[] = "9PLYND6YSJVCDE.";
static char server[] = "iot.eclipse.org"; //"broker.hivemq.com"; 
static byte buffer[128];
static WiFiClient wifiClient;

static PubSubClient client(server, 1883, callback, wifiClient);
static json jsonVar2;

//funciones privadas
static void callback(char* topic, byte* payload, unsigned int length) {
    Serial.print("Received message for topic ");
    Serial.print(topic);
    Serial.print("with length ");
    Serial.println(length);
    Serial.println("Message:");
    Serial.write(payload, length);
    Serial.println();
   
    int voltageAlarmAux;
    int currentAlarmAux;
    int powerAlarmAux;
    int hoursAux;
    int minutesAux;
    int secondsAux;
    int startAux;
    int offAux;
    
    systemStatus sysStatus; 
    
    String voltage_value = "";
    String current_value = "";
    String power_value = "";
    String hours_value = "";
    String minutes_value = "";
    String seconds_value = "";
    String start_value = "";
    String off_value = "";
    
    
    //Recepción de alarma de voltaje   
    if (!strncmp((char*)topic, "voltageAlarm", length)) {
        for (int i=0;i<length;i++) {
            voltage_value += (char)payload[i];
        }
    voltageAlarmAux = voltage_value.toInt();
    sysStatus.setVoltageAlarm(voltageAlarmAux);
    }
    
    //Recepción de alarma de corriente
    if (!strncmp((char*)topic, "currentAlarm", length)) {
        for (int i=0;i<length;i++) {
            current_value += (char)payload[i];
        }
    currentAlarmAux = current_value.toInt();
    sysStatus.setCurrentAlarm(currentAlarmAux);
    }
    
    //Recepción de alarma de potencia
    if (!strncmp((char*)topic, "powerAlarm", length)) {
        for (int i=0;i<length;i++) {
            power_value += (char)payload[i];
        }
    powerAlarmAux = power_value.toInt();
    sysStatus.setPowerAlarm(powerAlarmAux);
    }
    
    //Recepción de horas
    if (!strncmp((char*)topic, "hours", length)) {
        for (int i=0;i<length;i++) {
            hours_value += (char)payload[i];
        }
    hoursAux = hours_value.toInt();
    sysStatus.setHours(hoursAux);
    }
    
    //Recepción de minutos
    if (!strncmp((char*)topic, "minutes", length)) {
        for (int i=0;i<length;i++) {
            minutes_value += (char)payload[i];
        }
    minutesAux = minutes_value.toInt();
    sysStatus.setMinutes(minutesAux);  
    }
    
    //Recepción de seguntos
    if (!strncmp((char*)topic, "seconds", length)) {
        for (int i=0;i<length;i++) {
            seconds_value += (char)payload[i];
        }
    secondsAux = seconds_value.toInt();
    sysStatus.setSeconds(secondsAux);   
    }
    
    //Recepción estado start
    if (!strncmp((char*)topic, "start", length)) {
        for (int i=0;i<length;i++) {
            start_value += (char)payload[i];
        }
    startAux = start_value.toInt();
    sysStatus.setStart(startAux);  
    }
    
    //Apagado remoto
    if (!strncmp((char*)topic, "off", length)) {
        for (int i=0;i<length;i++) {
        off_value += (char)payload[i];
        }
    offAux = off_value.toInt();
    sysStatus.setOff(offAux);
    }
    
}

//funciones de acceso publico
void setupMQTT() {
    Serial.begin(115200);

    Serial.print("Attempting to connect to Network named: ");
    Serial.println(ssid);
    WiFi.begin(ssid, password);
    while ( WiFi.status() != WL_CONNECTED) {
      Serial.print(".");
      delay(300);
    }

    Serial.println("\nYou're connected to the network");
    Serial.println("Waiting for an ip address");

    while (WiFi.localIP() == INADDR_NONE) {
      Serial.print(".");
      delay(300);
    }

    Serial.println("\nIP Address obtained");
    printWifiStatus();
}

void loopMQTT() {
    systemStatus sysStatus;
    
    Event  myEvent;
    int hours = 0;
    int minutes = 0;
    int seconds =0;
    int start = 0;
    int totalTime =0;
    
  //Reconectar si se ha pedido la conexion
  if (!client.connected()) {
    Serial.println("Disconnected. Reconnecting....");

    if(!client.connect("launchPadClient")) {
      Serial.println("Connection failed");
    } else {
      myEvent.waitFor();
      client.publish("msgTopic", "Connection success");
      client.subscribe("voltageAlarm");
      client.subscribe("currentAlarm");
      client.subscribe("powerAlarm");
      client.subscribe("hours");
      client.subscribe("minutes");
      client.subscribe("seconds");
      client.subscribe("start");
      client.subscribe("off");
      }
    }
    
   //Temporización
    hours = sysStatus.getHours();
    minutes = sysStatus.getMinutes();
    seconds = sysStatus.getSeconds();
    start = sysStatus.getStart();
    
    totalTime = seconds + (minutes*60) + (hours*60*60); // A segundos
    
    while ((totalTime > 0) && (start==1)) {

        client.publish("JSON", jsonVar2.getPayload());
        free(jsonVar2.getPayload());
        
        delay(1000);
        totalTime--;
        
    } if ((totalTime == 0) && (start==1)) {
        start==0;
        sysStatus.setStart(start);
        client.publish("time","Tiempo finalizado");
    }
    
    client.poll();
    delay(1000);
  }

void printWifiStatus() {
    Serial.print("SSID: ");
    Serial.println(WiFi.SSID());

    IPAddress ip = WiFi.localIP();
    Serial.print("IP Address: ");
    Serial.println(ip);

    long rssi = WiFi.RSSI();
    Serial.print("signal strength (RSSI):");
    Serial.print(rssi);
    Serial.println(" dBm");
  }
