#include "sensors.h"
#include "system.h"


void setupSensors(){
    pinMode (VOLTAGE_PIN, INPUT);
    pinMode (CURRENT_PIN, INPUT);
    //Serial.begin(115200);
}

float fmap (float sensorValue, float sensorMin, float sensorMax, float outMin, float outMax)
{
  return (sensorValue - sensorMin) * (outMax - outMin) / (sensorMax - sensorMin) + outMin;
}

void loopSensors(){
    voltageSensor();
    currentSensor();
    sensorCalc();
}

void voltageSensor() {
    //Variable auxiliar de calculo de voltage
    float voltageAux;
    //Objeto de acceso a variables globales del sistema (miembros estaticos)
    systemStatus sysStatus;
    
    for(int i=0;i<SAMPLES;i++)
    {
        voltageAux += analogRead(VOLTAGE_PIN);
        delay(1);
    }

    voltageAux = (voltageAux*CALIBRATION_VOLTAGE)/SAMPLES;

    if(voltageAux< VOLTAGE_MIN){
        sysStatus.setVoltage(int(0));
    } else {
        sysStatus.setVoltage(voltageAux);
    }

    //Serial.print("Voltaje: "); Serial.print(sysVoltage.get()); Serial.println(" V");
}

void currentSensor() {
    //Variable auxiliar de calculo de corrient
    float currentAux;
    //Objeto de acceso a variables globales del sistema (miembros estaticos)
    systemStatus sysStatus;

    for(int i=0;i<SAMPLES;i++)
    {
        currentAux += analogRead(CURRENT_PIN);
        delay(1);
    }

    currentAux = (currentAux/SAMPLES)-CALIBRATION_CURRENT;
    //Conversión de lectura a amperios
    currentAux = fmap(currentAux, CURRENT_READ_MIN, CURRENT_READ_MAX, AMPS_MIN, AMPS_MAX); 

    if(currentAux < CURRENT_MIN){
        sysStatus.setCurrent(int(0));
    } else {
        sysStatus.setCurrent(currentAux);
    }

    //Serial.print("Current: "); Serial.print(sysCurrent.get()); Serial.println(" A");
}

void sensorCalc() {
    systemStatus sysStatus;
    
    sysStatus.calcPower();
    sysStatus.calcEnergy();
 
}
