#include "system.h"
#include <ti/runtime/wiring/Energia.h>

//Inicializacion variables del sistema
float systemStatus::voltage = 0;
float systemStatus::current = 0;
float systemStatus::energy  = 0;
float systemStatus::power   = 0;
int systemStatus::voltage_alarm = 253;
int systemStatus::current_alarm = 20;
int systemStatus::power_alarm = 5060;
bool  systemStatus::alarm   = false;
int systemStatus::hours = 0;
int systemStatus::minutes = 0;
int systemStatus::seconds = 0;
int systemStatus::start = 0;
int systemStatus::off = 0;


//Implementacion de getters
float systemStatus::getVoltage(void)
{
    return this->voltage;
}

float systemStatus::getCurrent(void)
{
    return this->current;
}

float systemStatus::getPower(void)
{   
    return this->power;
}

float systemStatus::getEnergy(void)
{ 
    return this->energy;
}

//Implementación de getters de alarma
int systemStatus::getVoltageAlarm(void)
{
    return this->voltage_alarm;
}

int systemStatus::getCurrentAlarm(void)
{
    return this->current_alarm;
}

int systemStatus::getPowerAlarm(void)
{
    return this->power_alarm;
}

bool systemStatus::getAlarm(void)
{
    return this->alarm;
}

int systemStatus::getOff(void)
{
    return this->off;
}

//Implementación de getters del temporizador
int systemStatus::getHours(void)
{
    return this->hours;
}

int systemStatus::getMinutes(void)
{
    return this->minutes;
}

int systemStatus::getSeconds(void)
{
    return this->seconds;
}

int systemStatus::getStart(void)
{
    return this->start;
}

//Implementacion de setters
void systemStatus::setVoltage(const float &voltage)
{
    this->voltage = voltage;
}

void systemStatus::setCurrent(const float &current)
{
    this->current = current;
}

//Implementación de setters de alarma
void systemStatus::setVoltageAlarm(const int  &voltage_alarm)
{
    this->voltage_alarm = voltage_alarm;
}

void systemStatus::setCurrentAlarm(const int &current_alarm)
{
    this->current_alarm = current_alarm;
}

void systemStatus::setPowerAlarm(const int &power_alarm)
{
    this->power_alarm = power_alarm;
}

void systemStatus::setAlarm(const bool &alarm)
{
    this->alarm = alarm;
}

void systemStatus::setOff(const int &off)
{
    this->off = off;
}

//Implementación de setters del temporizador
void systemStatus::setHours(const int  &hours)
{
    this->hours = hours;
}

void systemStatus::setMinutes(const int  &minutes)
{
    this->minutes = minutes;
}

void systemStatus::setSeconds(const int  &seconds)
{
    this->seconds = seconds;
}

void systemStatus::setStart(const int  &start)
{
    this->start = start;
}

//APIs  de calculo de variables de sistema
void systemStatus::calcPower(void)
{
    this->power = (this->voltage * this->current);
}

void systemStatus::calcEnergy(void)
{ 
    long  milisec = millis();
    long  time    = milisec/1000; // a segundos
    
    this->energy = ((this->power*time)/3600); // a kWh
    delay(1);
}

