#ifndef __SYSTEM_H__
#define __SYSTEM_H__

#include <stdbool.h>

class systemStatus
{
  private:
    //Variables de systema
    static float voltage;
    static float current;
    static float energy;
    static float power;
    static int voltage_alarm;
    static int current_alarm;
    static int power_alarm;
    static int energy_alarm;
    static bool  alarm;
    static int hours;
    static int minutes;
    static int seconds;
    static int start;
    static int off;
    
  public:
    // Getters
    float getVoltage(void);
    float getCurrent(void);
    float getEnergy (void);
    float getPower  (void);
    int getVoltageAlarm (void);
    int getCurrentAlarm (void);
    int getPowerAlarm (void);
    bool getAlarm  (void);
    int getHours (void);
    int getMinutes (void);
    int getSeconds (void);
    int getStart (void);
    int getOff (void);
    
    // Setters
    void setVoltage(const float &voltage);
    void setCurrent(const float &current);
    void setVoltageAlarm(const int &voltage_alarm);
    void setCurrentAlarm(const int &current_alarm);
    void setPowerAlarm(const int &power_alarm);
    void setAlarm  (const bool  &alarm);
    void setHours (const int &hours);
    void setMinutes (const int &minutes);
    void setSeconds (const int &seconds);
    void setStart (const int &start);
    void setOff (const int &off);

    //APIs  de calculo de variables de sistema
    void calcPower(void);
    void calcEnergy(void);
    
};

#endif



